#include <stdio.h>
#include "main.h"
#define MAX_NR_MODULES 50

typedef struct _module_list_item
{
	char module_name[20];
	int (*initialize_func)();
	int (*initialize_links_func)();
} module_list_item;

module_list_item module_list[MAX_NR_MODULES];

static int nr_registred_modules=0;
void (*dissect_top)(int,char*,int,lower_layer_info)=NULL; 

void register_with_giu(const char *modulename, void(*gui_callback_function)())
{
	fprintf(stdout, "registration module %s with gui\n", modulename);
} 

void register_with_filter_engine(const char *modulename, filterspec fspec,
 	void (*filter_compare_callback)())
{
	fprintf(stdout, "registration module %s with filtering engine\n", modulename);
} 

int register_module(char const name[], int (*initialize)(),
 int (*initialize_links)())
{
	if ( nr_registred_modules < MAX_NR_MODULES )
	{
		strcpy(module_list[nr_registred_modules].module_name,name);
		module_list[nr_registred_modules].initialize_func=initialize;
		module_list[nr_registred_modules].initialize_links_func
				=initialize_links;
		nr_registred_modules++;
		fprintf(stdout, "module %s successfull registration\n", name);
		return 1;
	}
	else
	{
		fprintf(stderr, "failed to register %s\n", name);
		return 0;
	}
}

int main(int argc, char **argv)
{
int i;
lower_layer_info li;
	li.a=1;
	fprintf(stdout, "===================================================\n");
	for( i=0; i < nr_registred_modules; i++)
	{
	int res;
		res=(module_list[i].initialize_func)();
		if (res != 1 ) 
		{	
			fprintf(stderr, "failed to initialize module %s\n",
			module_list[i].module_name );
 		}
		else
		{
			fprintf(stdout, "module %s initialized\n",
				module_list[i].module_name);
 		}
	}
	fprintf(stdout, "===================================================\n");
	for( i=0; i < nr_registred_modules; i++)
	{
	int res;
		res=(module_list[i].initialize_links_func)();
		if (res != 1 ) 
		{	
			fprintf(stderr, "failed to link module %s\n",
			module_list[i].module_name );
 		}
		else
		{
			fprintf(stdout, "module %s linked\n",
				module_list[i].module_name);
 		}
	}
	fprintf(stdout, "===================================================\n");
	if (dissect_top!=NULL)(dissect_top)(6,"a1b1c3",0,li);
	fprintf(stdout, "===================================================\n");
	if (dissect_top!=NULL)(dissect_top)(6,"a2f1c3",0,li);
	fprintf(stdout, "===================================================\n");

}


