#include "packet-frame-interface.h"
#include "main.h"
#include <stdio.h>
char const modulename[]="FRAME";

#define MAX_CHILDS 10
extern void (*dissect_top)(int,char*,int,lower_layer_info); 
typedef struct _frame_frame_child_table_item 
{
	char name[20];
	frame_type_discriminator discriminator;
	void (*dissect)(int, char *, int, lower_layer_info );
} frame_child_table_item;

static frame_child_table_item frame_child_table[MAX_CHILDS];
static int frame_nr_childs=0;

void frame_gui_callback_function(/* parameters: parent window handle etc */)
{
/*called when user presses settings menu intem for this specific module,
pops up a configuration window for protocol specific settings */
}

void frame_filter_compare_callback(/* parameters: data to compare and values to
compare with */)
{
/* called when the filtering engine needs to check if packet data match with
filter */
}
void dissect_frame(int length,char * buffer, int offset, lower_layer_info linfo)
{
int i;
	fprintf(stdout, "disscect: Frame %c\n",buffer[offset]);
	/* add stuff to lower layer info */
	for(i=0;i<frame_nr_childs;i++)
	{
		/* this could be done by hash table or module specific method */
		if ( (frame_type_discriminator)frame_child_table[i].discriminator == (frame_type_discriminator)buffer[offset+1])
		{ 
			fprintf(stdout, "found disscetor %p for module %s\n", 
				frame_child_table[i].dissect , frame_child_table[i].name);
			(frame_child_table[i].dissect)(length,buffer,offset+2, linfo);
			return;
		}
	}
} 

int initialize_frame()
{
filterspec fspec;
	fspec.a=1;
	dissect_top=dissect_frame;
	fprintf(stdout,"initializing module %s\n", modulename);

	register_with_giu(modulename, frame_gui_callback_function);
	register_with_filter_engine(modulename, fspec,
		frame_filter_compare_callback); 
	return 1;
}

int initialize_frame_links()
{
	fprintf(stdout, "linking module %s\n", modulename);
	return 1;
}

int frame_register_child_protocol(const char *name, frame_type_discriminator
dsc, void (*disscet)(int length, char *packetbuff, int offset,
lower_layer_info )) 
{
	fprintf(stdout, "registration of child protocol decoder %s:discriminator %c\n", name,dsc ); 
	strcpy(frame_child_table[frame_nr_childs].name, name); 
	frame_child_table[frame_nr_childs].discriminator=dsc; 
	frame_child_table[frame_nr_childs].dissect=disscet;
 	frame_nr_childs++;
	return 1;
}


static int frame_register_result=register_module(modulename, initialize_frame,
initialize_frame_links);
