#include "packet-frame-interface.h"
#include "packet-ipx-interface.h"
#include "main.h"
#include <stdio.h>
char const modulename[]="IPX";

#define IPX_MAX_CHILDS 10

typedef struct _IPX__child_table_item 
{
	char name[20];
	IPX_type_discriminator discriminator;
	void (*dissect)(int, char *, int, lower_layer_info );
} IPX_child_table_item;

static IPX_child_table_item IPX_child_table[IPX_MAX_CHILDS];
static int IPX_nr_childs=0;

void IPX_gui_callback_function(/* parameters: parent window handle etc */)
{
/*called when user presses settings menu intem for this specific module,
pops up a configuration window for protocol specific settings */
}

void IPX_filter_compare_callback(/* parameters: data to compare and values to
compare with */)
{
/* called when the filtering engine needs to check if packet data match with
filter */
}

int initialize_IPX()
{
filterspec fspec;
	fspec.a=1;
	fprintf(stdout,"initializing module %s\n", modulename);

	register_with_giu(modulename, IPX_gui_callback_function);
	register_with_filter_engine(modulename, fspec,
		IPX_filter_compare_callback); 
	return 1;
}

void dissect_IPX(int length,char * buffer, int offset, lower_layer_info linfo)
{
int i;
	fprintf(stdout, "disscect: %s %c\n",modulename,buffer[offset]);
	/* add stuff to lower layer info */
	for(i=0;i<IPX_nr_childs;i++)
	{
		/* this could be done by hash table or module specific method */
		if ((IPX_type_discriminator)IPX_child_table[i].discriminator == (IPX_type_discriminator)buffer[offset+1])
		{
                        fprintf(stdout, "found disscetor %p for module %s\n",
                                IPX_child_table[i].dissect , IPX_child_table[i].name);
			IPX_child_table[i].dissect(length,buffer,offset+2, linfo);
			return;
		}
	}
} 

int initialize_IPX_links()
{
	frame_register_child_protocol(modulename,'2',dissect_IPX);
	fprintf(stdout, "linking module %s to FRAME module\n", modulename);
	return 1;
}

int IPX_register_child_protocol(const char *name, IPX_type_discriminator dsc, void
(*disscet)(int length, char *packetbuff, int offset, lower_layer_info ))
{
	fprintf(stdout, "registration of child protocol decoder %s:discriminator %d\n",
		 name,dsc );
	strcpy(IPX_child_table[IPX_nr_childs].name, name);
	IPX_child_table[IPX_nr_childs].discriminator=dsc;
	IPX_child_table[IPX_nr_childs].dissect=disscet;
	IPX_nr_childs++; 	
}

static int IPX_register_result=register_module(modulename, initialize_IPX,
initialize_IPX_links);
