#include "packet-ip-interface.h"
#include "packet-udp-interface.h"
#include "main.h"
#include <stdio.h>
char const modulename[]="UDP";

#define UDP_MAX_CHILDS 10

typedef struct _udp__child_table_item 
{
	char name[20];
	udp_type_discriminator discriminator;
	void (*dissect)(int, char *, int, lower_layer_info );
} udp_child_table_item;

static udp_child_table_item udp_child_table[UDP_MAX_CHILDS];
static int udp_nr_childs=0;

void udp_gui_callback_function(/* parameters: parent window handle etc */)
{
/*called when user presses settings menu intem for this specific module,
pops up a configuration window for protocol specific settings */
}

void udp_filter_compare_callback(/* parameters: data to compare and values to
compare with */)
{
/* called when the filtering engine needs to check if packet data match with
filter */
}

int initialize_udp()
{
filterspec fspec;
	fspec.a=1;
	fprintf(stdout,"initializing module %s\n", modulename);

	register_with_giu(modulename, udp_gui_callback_function);
	register_with_filter_engine(modulename, fspec,
		udp_filter_compare_callback); 
	return 1;
}

void dissect_udp(int length,char * buffer, int offset, lower_layer_info linfo)
{
int i;
	fprintf(stdout, "disscect: %s %c\n",modulename,buffer[offset]);
	/* add stuff to lower layer info */
	for(i=0;i<udp_nr_childs;i++)
	{
		/* this could be done by hash table or module specific method */
		if ((udp_type_discriminator)udp_child_table[i].discriminator == (udp_type_discriminator)buffer[offset+1])
		{
                        fprintf(stdout, "found disscetor %p for module %s\n",
                                udp_child_table[i].dissect , udp_child_table[i].name);
			udp_child_table[i].dissect(length,buffer,offset+2, linfo);
			return;
		}
	}
} 

int initialize_udp_links()
{
	ip_register_child_protocol(modulename,'1',dissect_udp);
	fprintf(stdout, "linking module %s to IP module\n", modulename);
	return 1;
}

int udp_register_child_protocol(const char *name, udp_type_discriminator dsc, void
(*disscet)(int length, char *packetbuff, int offset, lower_layer_info ))
{
	fprintf(stdout, "registration of child protocol decoder %s:discriminator %c\n",
		 name,dsc );
	strcpy(udp_child_table[udp_nr_childs].name, name);
	udp_child_table[udp_nr_childs].discriminator=dsc;
	udp_child_table[udp_nr_childs].dissect=disscet;
	udp_nr_childs++; 	
}

static int udp_register_result=register_module(modulename, initialize_udp,
initialize_udp_links);
